/*
  L9110S_Motor_Driver_Example - Arduino sketch
  Thank you Banana Robotics for the Bulk of this code. 
   
  Connections:
   
    Arduino digital output D10 to motor driver input B-IA.
    Arduino digital output D11 to motor driver input B-IB.
    
    Motor driver VCC to operating voltage 5V.
    Motor driver GND to common ground.
    
    Motor driver MOTOR B screw terminals to a small motor.
     
*/
//connections
//Direction is B
#define bait_PWM 10 // Motor B PWM Speed
#define bait_DIR 11 // Motor B Direction

#define fish_PWM 5 // Motor A PWM Speed
#define fish_DIR 6 // Motor A Direction
 
// Fast and slow for bait
#define bait_SLOW 50  // arbitrary slow speed PWM duty cycle
#define bait_FAST 255 // arbitrary fast speed PWM duty cycle
// Fast and slow for fish
#define fish_SLOW 50  // arbitrary slow speed PWM duty cycle
#define fish_FAST 255 // arbitrary fast speed PWM duty cycle
#define fish_FAST_BACK 225 // arbitrary fast speed PWM duty cycle
// brief delay for abrupt motor changes
#define DIR_DELAY 20


//define variables
int swimming;                                               //  is the fish swimming?
int fishturntimer;                                          //  the timer after wich the fishs turn ends
int extramove;                                              //  the extra movement the bait can make
int currentpanel;                                           //  op welk panel is de vis
int scent;
int breaking;
int food;

int hookpanel;
int fishpanel;
int fishvakje;
int hookvakje;
int panelpower;
int distancefish;


int knopvisvooruit;
int knopvisachteruit;
int knopbaitvooruit;
int knopbaitachteruit;

bool won;
bool lost;
bool caught;                                                //  is the bait caught?
bool baitturn;                                              //  is it the baits turn?
bool fishmoved;                                             //  did the fish move?
bool paneldefine;                                           // panel word gedefineerd en doet wat het moet doen
bool canoperator;                                           // can u operate the game with the special things?

void setup()
{
  Serial.begin( 9600 );
  //motor B
  pinMode( bait_DIR, OUTPUT );
  pinMode( bait_PWM, OUTPUT );
  //Motor A
  pinMode( fish_DIR, OUTPUT );
  pinMode( fish_PWM, OUTPUT );


  
  pinMode(3,OUTPUT);                                            //Scent lampjes, analog write gebruiken, probeer niet over de 3v te gaan
  pinMode(4,OUTPUT);                                             // extra 5v voor de swimming druk knoop
  pinMode(7,OUTPUT);                                             // food lampje 1
 // pinMode(8,OUTPUT);                                             // food lampje 2
  pinMode(9,OUTPUT);                                             //vibratormoror
  pinMode(12, INPUT);                                           //swimming knop
  pinMode(13,OUTPUT);                                           //Swimming knop led
  pinMode(A0,INPUT);                                            //foodknop
  pinMode(A1,INPUT);                                            //Fish bewegen
  pinMode(A2,INPUT);                                            //fishbewegen
  pinMode(A3,INPUT);                                            // Bait bewegen
  pinMode(A4,INPUT);                                            // **

  
  caught = false  ;                                             // zet caught op false
  baitturn = false;                                            //zet de baitturn op true
  fishmoved = false;
  paneldefine = false;
  canoperator = false;

  
  
}
 
void loop()
  {
      
                                 //A1 = vis vooruit      A2 = bait vooruit     A3 = bait achteruit   A4= vis achteruit
    /*  knopjes om de vis en bait goed te zetten
     *   
     *   
     *   
     *   
     */
       

//       if (digitalRead(A5) == 1){
//          
//            digitalWrite( bait_DIR, HIGH );
//            digitalWrite( bait_PWM, HIGH );
//  
//            digitalWrite( fish_DIR, HIGH );
//            digitalWrite( fish_PWM, HIGH );
//
//        }
//        if (digitalRead(A1) == 1){                                                //vis achteruit
//        //knopvisachteruit = digitalRead(A2);
//   
//          digitalWrite( fish_DIR, LOW ); // direction = reverse      
//          analogWrite( fish_PWM, fish_FAST_BACK ); // PWM speed = fast
//          
//        }
//        if (digitalRead(A2) == 1){                                               // vis vooruit
//        knopbaitvooruit = digitalRead(A3);
//     
//          digitalWrite( fish_DIR, HIGH ); // direction = forward      
//          analogWrite( fish_PWM, 255-fish_FAST ); // PWM speed = fast
//        }
//        if (digitalRead(A3) == 1){                                               // aas achteruit
//        knopbaitachteruit = digitalRead(A4);
//
//          digitalWrite( bait_DIR, LOW ); // direction = reverse      
//          analogWrite( bait_PWM, bait_FAST ); // PWM speed = fast
//        }
//        if (digitalRead(A4) == 1){
//          digitalWrite( bait_DIR, HIGH ); // direction = forward                  // aas vooruit
//          analogWrite( bait_PWM, 255-bait_FAST ); // PWM speed = fast
//          
//        }

        
       /*done
        * 
        * 
        */






    swimming = digitalRead(12);                                 // zoek input voor de swimming
    
      Serial.print(digitalRead(12));

    /* dit gebeurt allemaal alleen als het aas niet aan de beurt is.
     * de beurt van de vis defineren. Als de zwem knop ingedrukt is gaat de vis vooruit. laat de knop los en de vis zal stoppen.
     * Als de vis het aas heeft gevangen al, neemt hij het aas mee terug.
     * zodra je beweegt, word de timer gereset en zal het systeem registreren dat je bent bewogen.
     * 
     */
    if (baitturn == false){                                               // als het niet de bait beurt is
       if (swimming == 1){                                                // als het niet de bait beurt is, en als de zwem knop ingedrukt is
       ++ distancefish;
       canoperator = false;
       fishmoved = true;                                                   // zet fishmoved op true
       fishturntimer = 2;                                              // zet de timer op 1
        if (caught == true){                                              //als het niet de bait beurt is, de zwem knop ingedrukt is, en het aas gevangen is
          //fish reverse
          -- distancefish;
          -- distancefish;
          digitalWrite( fish_DIR, HIGH ); // direction = forward
          analogWrite( fish_PWM, 255-fish_FAST ); // PWM speed = fast
          
          analogWrite(9,80);
          //bait reverse
          digitalWrite( bait_DIR, LOW ); // direction = reverse
          analogWrite( bait_PWM, bait_FAST ); // PWM speed = fast
          }
        else{                                                             //als het niet de bait beurt is, de zwem knop ingedrukt is, en het aas niet gevangen is
          //fish
          digitalWrite( fish_DIR, LOW ); // direction = reverse
          analogWrite( fish_PWM, fish_FAST_BACK ); // PWM speed = fast
         }
        }
        else{                                                               // als de zwem knop niet ingedrukt is
          //fish stil                                                        
          digitalWrite( fish_DIR, HIGH );
          digitalWrite( fish_PWM, HIGH );
          //bait stil
          digitalWrite( bait_DIR, HIGH );
          digitalWrite( bait_PWM, HIGH );
          
           analogWrite(9,0);
           }
        }



    /*
     * defineren van de timer
     * als het aas niet aan de beurt is, de vis niet zwemt, maar de vis wel bewogen heeft.
     * dan telt het systeem tot 600, waarna het de beurt geeft aan het aas, de timer reset en de vis 'onbewogen' maakt
     */
    if (baitturn == false){
      if (swimming == 0){
        if(fishmoved == true){
          if (fishturntimer == 1800){                                 // als de timer voorbij 5 sec. is, zet de baitturn op true
             baitturn = true;
             fishturntimer = 1;
             fishmoved = false;
          }
          else{
             ++ fishturntimer;                                         // increase timer
          //  Serial.println(fishturntimer);                           // print timer nummer
          }
       }
      }
    } 

    /* de turn van het aas word gedefineerd. Dit gebeurt allemaal alleen als het aas aan de beurt is.
     * defineer hoeveel extra stappen het aas gaat zetten, random van 0-2 extra vakken.
     * het aas beweegt het standaard aantal vakken plus de extra.
     * als het aas gevangen is trekt het de vis mee.
     * hierna zet het het aas en de vis stil.
     * aan het eind word de panel definer ge-enabled.
     */
    if(baitturn == true){
      extramove = random(0-2);
      extramove * 1000;
      if (caught == false){
          //bait vooruit
          digitalWrite( bait_DIR, HIGH ); // direction = forward
          analogWrite( bait_PWM, 255-bait_FAST ); // PWM speed = fast 
          // duuratie
          delay(1000 + extramove);
          Serial.print("stopping");
          //bait stil
          digitalWrite( bait_DIR, HIGH );
          digitalWrite( bait_PWM, HIGH );
      }
      else{
          // bait vooruit
          digitalWrite( bait_DIR, HIGH ); // direction = forward
          analogWrite( bait_PWM, 255-bait_FAST ); // PWM speed = fast 
          //fish forward
          digitalWrite( fish_DIR, HIGH ); // direction = forward
          analogWrite( fish_PWM, 255-fish_FAST ); // PWM speed = fast
          // extra lang gebaseerd op de extramovement
          delay(1000 + extramove);
          Serial.print("stopping");
          // bait stil
          digitalWrite( bait_DIR, HIGH );
          digitalWrite( bait_PWM, HIGH );
          //fish stil                                                        
          digitalWrite( fish_DIR, HIGH );
          digitalWrite( fish_PWM, HIGH );
      }
      paneldefine = true;
    }                                                                         // baitturn is nu false, en het ding is gestopt met bewegen
   /* als panel define aanstaat, kijk op welke panel de vis staat.
    * check dan of die panel een speciale eigenschap heeft.
    * als de panel een power heeft, check welke het is.
    * voer de powerup uit.
    * powerups: Break, Food, Scent, unscent
    */
    if(paneldefine == true){

     if (panelpower == 1){
      scent + 1;
      if (scent == 3);{
        lost = true;
      }
     }
     if (panelpower == 2){
      food + 1;
      if( food == 3){
        food - 1;
      }
     }
     if (panelpower == 3){
      breaking + 1;
      if (breaking == 3){
        won = true;
      }
     }
     if (panelpower == 4){
      scent = 0;
     }
    }

    // lampjes bijhouden hier

    //scent
    if (scent == 0){
      analogWrite(3,0);
    }
    if (scent == 1){
      analogWrite(3,40);
    }
    if (scent == 2){
      analogWrite(3,80);
    }
    if (scent == 3){
      analogWrite(3,140);
    }


////   breaking 
//    if (breaking == 0){
//      digitalWrite(1,LOW);
//      digitalWrite(2,LOW);
//    }
//    if (breaking == 1){
//      digitalWrite(1,HIGH);
//      digitalWrite(2,LOW);
//    }
//    if (breaking == 2){
//      digitalWrite(1,HIGH);
//      digitalWrite(2,HIGH);
//    }

      if(food == 0){
        digitalWrite(7,LOW);
      }if(food == 1){
        digitalWrite(7,HIGH);
      }

//
//      if (baitturn == false){
//        digitalWrite(13,HIGH);
//      }
      
    baitturn = false;
    paneldefine = false;
    canoperator = true;
 }
